//+------------------------------------------------------------------+
//|                                             Donchian Std Dev.mq4 |
//|                         
//|                                                 
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_width1  1
#property  indicator_width2  1
 
//---- indicator parameters
extern int periods=13;
extern int shift=0; 
extern int BandPeriod = 21;
extern double const=  1.3;
//---- indicator buffers
double     upper[];
double     lower[];
double     center[]; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(Digits);   
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);

      
//---- indicator buffers mapping
   SetIndexBuffer(1,upper);
   SetIndexBuffer(2,lower);
   SetIndexBuffer(0,center);
   
//   SetIndexBuffer(4,center);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Simple Donchian Std Dev ("+periods+")");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| now do the dance.                           |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   double up,dn,ctr;

   int counted_bars=IndicatorCounted();
   i=Bars-counted_bars-1;           
   while(i>=0)       
   {
      up=iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,periods,i+shift));
      dn=iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,periods,i+shift));
      ctr=up-MathAbs((up-dn)/2);
      center[i]=ctr;
      i--;
   }
   i=Bars-counted_bars-1;           
   while(i>=0)       
   {
      upper[i]=center[i]+(const*StDev(center,BandPeriod));
      lower[i]=center[i]-(const*StDev(center,BandPeriod));
      i--;
   }   
      
   return(0);
  }
  
double StDev(double& Data[], int Per)
{
  return(MathSqrt(Variance(Data,Per)));
}

double Variance(double& Data[], int Per)
{
  double sum, ssum;

  for (int i=0; i<Per; i++)
  {
    sum += Data[i];
    ssum += MathPow(Data[i],2);
  }

  return((ssum*Per - sum*sum)/(Per*(Per-1)));
}
//+------------------------------------------------------------------+  